#!/usr/bin/bash
#set -x
WORKDIR=$(pwd)
LOGFILE=/var/log/$(basename $0).excute.log
CURRENTTIME=$(date +%Y%m%d%H%M%S)

function ExecWithLog()
{
echo "begin execute $* " >> ${LOGFILE}
$* >> ${LOGFILE} 2>&1
if [[ $? == 0 ]]; then
echo "execute $* successful." >> ${LOGFILE}
else
echo "execute $* failed." >> ${LOGFILE}
fi
}

function EchoWithLog()
{
echo "begin execute echo $1 > $2 " >> ${LOGFILE}
if [[ ! -f $2 ]]; then
echo "not exists $2" >> ${LOGFILE}
return 
fi
echo $1 > $2 
if [[ $? == 0 ]]; then
echo "execute $* successful." >> ${LOGFILE}
else
echo "execute $* failed." >> ${LOGFILE}
fi
}

function Swapfile()
{
if [[ -d /sys/kernel/debug/swap_test ]];then
echo /data/swap_file > /sys/kernel/debug/swap_test/swapfile
fi
}

function main()
{
    [[ ! -f ${LOGFILE} ]] && ( touch ${LOGFILE} )
    echo "" > ${LOGFILE}
    echo "begin execute modify cfg, time is : ${CURRENTTIME}" >> ${LOGFILE}
    ExecWithLog chmod 660 /sys/devices/system/cpu/cpu0/cpufreq/scaling_max_freq
    ExecWithLog chmod 660 /sys/devices/system/cpu/cpu0/cpufreq/scaling_min_freq
    ExecWithLog chmod 660 /sys/devices/system/cpu/cpu4/cpufreq/scaling_max_freq
    ExecWithLog chmod 660 /sys/devices/system/cpu/cpu4/cpufreq/scaling_min_freq
    ExecWithLog chmod 660 /sys/devices/system/cpu/cpu6/cpufreq/scaling_max_freq
    ExecWithLog chmod 660 /sys/devices/system/cpu/cpu6/cpufreq/scaling_min_freq
    ExecWithLog chmod 660 /sys/devices/virtual/thermal/thermal_zone0/boost
    ExecWithLog chmod 660 /sys/devices/virtual/thermal/thermal_zone0/boost_timeout 
    ExecWithLog chmod 660 /sys/class/devfreq/gpufreq/max_freq
    ExecWithLog chmod 660 /sys/class/devfreq/gpufreq/min_freq
    ExecWithLog chmod 660 /sys/class/devfreq/gpufreq/cur_freq
    ExecWithLog chmod 660 /sys/class/devfreq/gpufreq/available_frequencies
    ExecWithLog chmod 660 /sys/class/devfreq/gpufreq/mali_ondemand/animation_boost
    ExecWithLog chmod 660 /sys/class/devfreq/gpufreq/mali_ondemand/animation_boost_freq
    ExecWithLog chmod 660 /sys/class/devfreq/gpufreq/mali_ondemand/cl_boost
    ExecWithLog chmod 660 /sys/class/devfreq/gpufreq/mali_ondemand/cl_boost_freq
    ExecWithLog chmod 644 /sys/class/devfreq/ddrfreq/max_freq
    ExecWithLog chmod 644 /sys/class/devfreq/ddrfreq/min_freq
    ExecWithLog chmod 644 /sys/class/devfreq/ddrfreq/ddr_bandwidth
    ExecWithLog chmod 644 /sys/class/devfreq/ddrfreq/cur_freq
    ExecWithLog chmod 644 /sys/class/devfreq/ddrfreq/available_frequencies
    ExecWithLog chmod 660 /dev/acpuddr_link_governor_level   
    ExecWithLog chmod 0660 /sys/kernel/eas/boost
    ExecWithLog chmod 0660 /sys/kernel/eas/capacity_margin
    ExecWithLog chmod 0660 /sys/kernel/eas/task_boost_limit
    ExecWithLog chmod 660 /sys/class/devfreq/l3c_devfreq/max_freq
    ExecWithLog chmod 660 /sys/class/devfreq/l3c_devfreq/min_freq
    ExecWithLog chmod 660 /sys/class/devfreq/l3p_karma/max_freq
    ExecWithLog chmod 660 /sys/class/devfreq/l3p_karma/min_freq
    ExecWithLog chmod 0660 /sys/class/thermal/thermal_zone0/mode
    ExecWithLog chmod 0660 /sys/class/thermal/thermal_zone0/trip_point_0_temp
    ExecWithLog chmod 0660 /sys/class/thermal/thermal_zone0/trip_point_1_temp
    ExecWithLog chmod 0660 /sys/class/thermal/thermal_zone0/sustainable_power    
    ExecWithLog chmod 0660 /sys/class/thermal/thermal_zone1/mode
    ExecWithLog chmod 0440 /sys/class/thermal/thermal_zone1/type
    ExecWithLog chmod 0660 /sys/class/thermal/thermal_zone1/trip_point_0_temp
    ExecWithLog chmod 0660 /sys/class/thermal/thermal_zone1/sustainable_power
    ExecWithLog chmod 0660 /sys/kernel/perfhub/cpuaffinity   
    ExecWithLog chmod 0660 /dev/cpu_dma_latency 
    ExecWithLog chmod 0660 /sys/devices/platform/fe140000.mali/power_policy
    ExecWithLog chmod 660 /dev/hisi_perf_ctrl
    ExecWithLog chmod 0660 /sys/class/devfreq/gpufreq/gpu_scene_aware/scene
    ExecWithLog chmod 0660 /sys/class/devfreq/gpufreq/gpu_scene_aware/user_set_freq
    ExecWithLog mkdir -p /dev/cpuctl
    ExecWithLog mount -t cgroup -o cpu cpu /dev/cpuctl
    ExecWithLog chmod 0666 /dev/cpuctl/tasks    
    ExecWithLog mkdir -p /dev/cpuctl/limit
    ExecWithLog chmod 0644 /dev/cpuctl/limit/tasks         
    ExecWithLog mkdir -p /dev/cpuset
    ExecWithLog mount -t cgroup -o cpuset cpuset /dev/cpuset
    ExecWithLog mount -t cgroup -o blkio blkio /dev/cpuset
    ExecWithLog mkdir -p /dev/cpuset/foreground     
    ExecWithLog mkdir -p /dev/cpuset/foreground/boost
    ExecWithLog mkdir -p /dev/cpuset/background     
    ExecWithLog mkdir -p /dev/cpuset/system-background    
    ExecWithLog mkdir -p /dev/cpuset/top-app         
    ExecWithLog chmod 0775 /dev/cpuset/system-background    
    ExecWithLog chmod 0664 /dev/cpuset/foreground/tasks
    ExecWithLog chmod 0664 /dev/cpuset/foreground/boost/tasks
    ExecWithLog chmod 0664 /dev/cpuset/background/tasks
    ExecWithLog chmod 0664 /dev/cpuset/system-background/tasks
    ExecWithLog chmod 0664 /dev/cpuset/top-app/tasks
    ExecWithLog chmod 0664 /dev/cpuset/tasks    
    ExecWithLog mkdir -p /dev/cpuset/vip    
    ExecWithLog chmod 0664 /dev/cpuset/vip/tasks     
    ExecWithLog mkdir -p /dev/stune
    ExecWithLog mount -t cgroup -o schedtune schedtune /dev/stune
    ExecWithLog mkdir -p /dev/stune/vip
    ExecWithLog chmod 0664 /dev/stune/vip/tasks
    ExecWithLog chmod 0664 /dev/stune/vip/schedtune.boost
    ExecWithLog chmod 0660 /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor
    ExecWithLog chmod 0660 /sys/devices/system/cpu/cpu0/cpufreq/scaling_setspeed
    ExecWithLog chmod 0660 /sys/devices/system/cpu/cpu4/cpufreq/scaling_governor
    ExecWithLog chmod 0660 /sys/devices/system/cpu/cpu4/cpufreq/scaling_setspeed
    ExecWithLog chmod 0660 /sys/devices/system/cpu/cpu6/cpufreq/scaling_governor
    ExecWithLog chmod 0660 /sys/devices/system/cpu/cpu6/cpufreq/scaling_setspeed
    ExecWithLog chmod 660 /sys/kernel/debug/freqdump/loadmonitor_enable
    ExecWithLog chmod 660 /sys/kernel/debug/freqdump/loadmonitor_disable
    ExecWithLog chmod 660 /sys/devices/system/cpu/cpu0/core_ctl/min_cpus
    ExecWithLog chmod 660 /sys/devices/system/cpu/cpu4/core_ctl/min_cpus
    ExecWithLog chmod 660 /sys/devices/system/cpu/cpu4/core_ctl/max_cpus
    ExecWithLog chmod 660 /sys/devices/system/cpu/cpu4/core_ctl/boost
    ExecWithLog chmod 660 /sys/devices/system/cpu/cpu6/core_ctl/min_cpus
    ExecWithLog chmod 660 /sys/devices/system/cpu/cpu6/core_ctl/max_cpus
    ExecWithLog chmod 660 /sys/devices/system/cpu/cpu6/core_ctl/boost
    ExecWithLog chmod 660 /sys/devices/system/cpu/cpu6/core_ctl/spread_affinity
    ExecWithLog chmod 0660 /sys/class/devfreq/memlat_cpu0/polling_interval
    ExecWithLog chmod 0660 /sys/class/devfreq/memlat_cpu0/mem_latency/target_ratio
    ExecWithLog chmod 0660 /sys/class/devfreq/memlat_cpu0/mem_latency/monitor_enable
    ExecWithLog chmod 0660 /sys/class/devfreq/memlat_cpu4/polling_interval
    ExecWithLog chmod 0660 /sys/class/devfreq/memlat_cpu4/mem_latency/target_ratio
    ExecWithLog chmod 0660 /sys/class/devfreq/memlat_cpu4/mem_latency/monitor_enable
    ExecWithLog chmod 0660 /sys/class/devfreq/memlat_cpu6/polling_interval
    ExecWithLog chmod 0660 /sys/class/devfreq/memlat_cpu6/mem_latency/target_ratio
    ExecWithLog chmod 0660 /sys/class/devfreq/memlat_cpu6/mem_latency/monitor_enable
    ExecWithLog chmod 0660 /sys/class/devfreq/l3_memlat_cpu0/polling_interval
    ExecWithLog chmod 0660 /sys/class/devfreq/l3_memlat_cpu0/mem_latency/target_ratio
    ExecWithLog chmod 0660 /sys/class/devfreq/l3_memlat_cpu0/mem_latency/monitor_enable
    ExecWithLog chmod 0660 /sys/class/devfreq/l3_memlat_cpu4/polling_interval
    ExecWithLog chmod 0660 /sys/class/devfreq/l3_memlat_cpu4/mem_latency/target_ratio
    ExecWithLog chmod 0660 /sys/class/devfreq/l3_memlat_cpu4/mem_latency/monitor_enable
    ExecWithLog chmod 0660 /sys/class/devfreq/l3_memlat_cpu6/polling_interval
    ExecWithLog chmod 0660 /sys/class/devfreq/l3_memlat_cpu6/mem_latency/target_ratio
    ExecWithLog chmod 0660 /sys/class/devfreq/l3_memlat_cpu6/mem_latency/monitor_enable
    

     
    EchoWithLog "2133000000" /sys/class/devfreq/ddrfreq/min_freq
    EchoWithLog "2133000000" /sys/class/devfreq/ddrfreq/max_freq
    EchoWithLog "2133000000" /sys/class/devfreq/ddrfreq_latency/min_freq
    EchoWithLog "2133000000" /sys/class/devfreq/ddrfreq_latency/max_freq
    EchoWithLog "2133000000" /sys/class/devfreq/ddrfreq_up_threshold/max_freq
    EchoWithLog "2133000000" /sys/class/devfreq/ddrfreq_up_threshold/min_freq
    EchoWithLog "1024" /dev/cpuctl/cpu.shares
    EchoWithLog "800000" /dev/cpuctl/cpu.rt_runtime_us
    EchoWithLog "1000000" /dev/cpuctl/cpu.rt_period_us
    EchoWithLog "1024" /dev/cpuctl/limit/cpu.shares
    EchoWithLog "800000" /dev/cpuctl/limit/cpu.rt_runtime_us
    EchoWithLog "1000000" /dev/cpuctl/limit/cpu.rt_period_us
    EchoWithLog "0-7" /dev/cpuset/foreground/cpus
    EchoWithLog "0" /dev/cpuset/foreground/mems
    EchoWithLog "0-7" /dev/cpuset/foreground/boost/cpus
    EchoWithLog "0" /dev/cpuset/foreground/boost/mems
    EchoWithLog "0-3" /dev/cpuset/background/cpus
    EchoWithLog "0" /dev/cpuset/background/mems
    EchoWithLog "0-3" /dev/cpuset/system-background/cpus
    EchoWithLog "0" /dev/cpuset/system-background/mems
    EchoWithLog "0-7" /dev/cpuset/top-app/cpus
    EchoWithLog "0" /dev/cpuset/top-app/mems
    EchoWithLog "0-7" /dev/cpuset/vip/cpus
    EchoWithLog "0" /dev/cpuset/vip/mems
    EchoWithLog "1" /dev/stune/top-app/schedtune.prefer_idle
    EchoWithLog "1" /dev/stune/vip/schedtune.prefer_idle
    EchoWithLog "1" /dev/stune/top-app/schedtune.top_task
    EchoWithLog "19" /dev/stune/top-app/schedtune.boost
    EchoWithLog "1"  /dev/stune/vip/schedtune.top_task
    EchoWithLog "19" /dev/stune/vip/schedtune.boost
    EchoWithLog "1" /dev/stune/foreground/schedtune.top_task
    EchoWithLog "75" /sys/devices/system/cpu/cpu4/core_ctl/busy_thres
    EchoWithLog "40" /sys/devices/system/cpu/cpu4/core_ctl/idle_thres
    EchoWithLog "80" /sys/devices/system/cpu/cpu4/core_ctl/offline_delay_ms
    EchoWithLog "4" /sys/devices/system/cpu/cpu4/core_ctl/task_thres
    EchoWithLog "2" /sys/devices/system/cpu/cpu4/core_ctl/min_cpus
    EchoWithLog "75" /sys/devices/system/cpu/cpu6/core_ctl/busy_thres
    EchoWithLog "40" /sys/devices/system/cpu/cpu6/core_ctl/idle_thres
    EchoWithLog "90" /sys/devices/system/cpu/cpu6/core_ctl/offline_delay_ms
    EchoWithLog "4" /sys/devices/system/cpu/cpu6/core_ctl/task_thres
    EchoWithLog "80" /sys/devices/system/cpu/cpu6/core_ctl/open_thres
    EchoWithLog "30" /sys/devices/system/cpu/cpu6/core_ctl/close_thres
    EchoWithLog "2" /sys/devices/system/cpu/cpu6/core_ctl/min_cpus
    EchoWithLog "2" /sys/devices/system/cpu/cpu6/core_ctl/max_cpus
    EchoWithLog "19" /sys/devices/system/cpu/cpu6/core_ctl/update_interval_ms
    EchoWithLog  "0" /sys/devices/system/cpu/cpu6/core_ctl/spread_affinity
    EchoWithLog "0" /sys/class/devfreq/ddrfreq/min_freq
    EchoWithLog "0" /sys/class/devfreq/ddrfreq/max_freq
    EchoWithLog "0" /sys/class/devfreq/ddrfreq_latency/min_freq
    EchoWithLog "0" /sys/class/devfreq/ddrfreq_latency/max_freq
    EchoWithLog "2133000000" /sys/class/devfreq/ddrfreq_up_threshold/max_freq
    EchoWithLog "2133000000" /sys/class/devfreq/ddrfreq_up_threshold/min_freq
    EchoWithLog "mem_latency" /sys/class/devfreq/memlat_cpu0/governor
    EchoWithLog "20" /sys/class/devfreq/memlat_cpu0/polling_interval
    EchoWithLog "415000000" /sys/class/devfreq/memlat_cpu0/min_freq
    EchoWithLog "2133000000" /sys/class/devfreq/memlat_cpu0/max_freq
    EchoWithLog "400" /sys/class/devfreq/memlat_cpu0/mem_latency/target_ratio
    EchoWithLog "mem_latency" /sys/class/devfreq/memlat_cpu4/governor
    EchoWithLog "20" /sys/class/devfreq/memlat_cpu4/polling_interval
    EchoWithLog "415000000" /sys/class/devfreq/memlat_cpu4/min_freq
    EchoWithLog "2133000000" /sys/class/devfreq/memlat_cpu4/max_freq
    EchoWithLog "400" /sys/class/devfreq/memlat_cpu4/mem_latency/target_ratio
    EchoWithLog "mem_latency" /sys/class/devfreq/memlat_cpu6/governor
    EchoWithLog "20" /sys/class/devfreq/memlat_cpu6/polling_interval
    EchoWithLog "415000000" /sys/class/devfreq/memlat_cpu6/min_freq
    EchoWithLog "2133000000" /sys/class/devfreq/memlat_cpu6/max_freq
    EchoWithLog "400" /sys/class/devfreq/memlat_cpu6/mem_latency/target_ratio
    EchoWithLog "mem_latency" /sys/class/devfreq/l3_memlat_cpu0/governor
    EchoWithLog "20" /sys/class/devfreq/l3_memlat_cpu0/polling_interval
    EchoWithLog "415000000" /sys/class/devfreq/l3_memlat_cpu0/min_freq
    EchoWithLog "1556000000" /sys/class/devfreq/l3_memlat_cpu0/max_freq
    EchoWithLog "400" /sys/class/devfreq/l3_memlat_cpu0/mem_latency/target_ratio
    EchoWithLog "mem_latency" /sys/class/devfreq/l3_memlat_cpu4/governor
    EchoWithLog "20" /sys/class/devfreq/l3_memlat_cpu4/polling_interval
    EchoWithLog "415000000" /sys/class/devfreq/l3_memlat_cpu4/min_freq
    EchoWithLog "1556000000" /sys/class/devfreq/l3_memlat_cpu4/max_freq
    EchoWithLog "400" /sys/class/devfreq/l3_memlat_cpu4/mem_latency/target_ratio
    EchoWithLog "mem_latency" /sys/class/devfreq/l3_memlat_cpu6/governor
    EchoWithLog "20" /sys/class/devfreq/l3_memlat_cpu6/polling_interval
    EchoWithLog "415000000" /sys/class/devfreq/l3_memlat_cpu6/min_freq
    EchoWithLog "1556000000" /sys/class/devfreq/l3_memlat_cpu6/max_freq
    EchoWithLog "400" /sys/class/devfreq/l3_memlat_cpu6/mem_latency/target_ratio
    EchoWithLog "schedutil" /sys/devices/system/cpu/cpu0/cpufreq/scaling_governor
    EchoWithLog "50" /sys/devices/system/cpu/cpu0/cpufreq/schedutil/go_hispeed_load
    EchoWithLog "1700000" /sys/devices/system/cpu/cpu0/cpufreq/schedutil/hispeed_freq
    EchoWithLog "70" /sys/devices/system/cpu/cpu0/cpufreq/schedutil/target_loads
    EchoWithLog "10000" /sys/devices/system/cpu/cpu0/cpufreq/schedutil/above_hispeed_delay
    EchoWithLog "79000" /sys/devices/system/cpu/cpu0/cpufreq/schedutil/min_sample_time
    EchoWithLog "160000" /sys/devices/system/cpu/cpu0/cpufreq/schedutil/boostpulse_duration
    EchoWithLog "0" /sys/devices/system/cpu/cpu0/cpufreq/schedutil/fast_ramp_down
    EchoWithLog "1" /sys/devices/system/cpu/cpu0/cpufreq/schedutil/fast_ramp_up
    EchoWithLog "3" /sys/devices/system/cpu/cpu0/cpufreq/schedutil/top_task_hist_size
    EchoWithLog "1" /sys/devices/system/cpu/cpu0/cpufreq/schedutil/top_task_stats_policy
    EchoWithLog "60000000" /sys/devices/system/cpu/cpu0/cpufreq/schedutil/ed_task_running_duration
    EchoWithLog "60000000" /sys/devices/system/cpu/cpu0/cpufreq/schedutil/ed_new_task_running_duration
    EchoWithLog "schedutil" /sys/devices/system/cpu/cpu4/cpufreq/scaling_governor
    EchoWithLog "70" /sys/devices/system/cpu/cpu4/cpufreq/schedutil/go_hispeed_load
    EchoWithLog "1786000" /sys/devices/system/cpu/cpu4/cpufreq/schedutil/hispeed_freq
    EchoWithLog "80" /sys/devices/system/cpu/cpu4/cpufreq/schedutil/target_loads
    EchoWithLog "10000" /sys/devices/system/cpu/cpu4/cpufreq/schedutil/above_hispeed_delay
    EchoWithLog "79000" /sys/devices/system/cpu/cpu4/cpufreq/schedutil/min_sample_time
    EchoWithLog "39000" /sys/devices/system/cpu/cpu4/cpufreq/schedutil/timer_slack
    EchoWithLog "0" /sys/devices/system/cpu/cpu4/cpufreq/schedutil/fast_ramp_down
    EchoWithLog "1" /sys/devices/system/cpu/cpu4/cpufreq/schedutil/fast_ramp_up
    EchoWithLog "3" /sys/devices/system/cpu/cpu4/cpufreq/schedutil/top_task_hist_size
    EchoWithLog "1" /sys/devices/system/cpu/cpu4/cpufreq/schedutil/top_task_stats_policy
    EchoWithLog "70000000" /sys/devices/system/cpu/cpu4/cpufreq/schedutil/ed_task_running_duration
    EchoWithLog "60000000" /sys/devices/system/cpu/cpu4/cpufreq/schedutil/ed_new_task_running_duration
    EchoWithLog "schedutil" /sys/devices/system/cpu/cpu6/cpufreq/scaling_governor
    EchoWithLog "90" /sys/devices/system/cpu/cpu6/cpufreq/schedutil/go_hispeed_load
    EchoWithLog "2112000" /sys/devices/system/cpu/cpu6/cpufreq/schedutil/hispeed_freq
    EchoWithLog "80" /sys/devices/system/cpu/cpu6/cpufreq/schedutil/target_loads
    EchoWithLog "10000" /sys/devices/system/cpu/cpu6/cpufreq/schedutil/above_hispeed_delay
    EchoWithLog "79000" /sys/devices/system/cpu/cpu6/cpufreq/schedutil/min_sample_time
    EchoWithLog "39000" /sys/devices/system/cpu/cpu6/cpufreq/schedutil/timer_slack
    EchoWithLog "0" /sys/devices/system/cpu/cpu6/cpufreq/schedutil/fast_ramp_down
    EchoWithLog "1" /sys/devices/system/cpu/cpu6/cpufreq/schedutil/fast_ramp_up
    EchoWithLog "3" /sys/devices/system/cpu/cpu6/cpufreq/schedutil/top_task_hist_size
    EchoWithLog "1" /sys/devices/system/cpu/cpu6/cpufreq/schedutil/top_task_stats_policy
    EchoWithLog "60000000" /sys/devices/system/cpu/cpu6/cpufreq/schedutil/ed_task_running_duration
    EchoWithLog "40000000" /sys/devices/system/cpu/cpu6/cpufreq/schedutil/ed_new_task_running_duration
	
    EchoWithLog "0" /sys/class/devfreq/ddrfreq/min_freq
    EchoWithLog "0" /sys/class/devfreq/ddrfreq/max_freq
    EchoWithLog "0" /sys/class/devfreq/ddrfreq_latency/min_freq
    EchoWithLog "0" /sys/class/devfreq/ddrfreq_latency/max_freq
    EchoWithLog "2133000000" /sys/class/devfreq/ddrfreq_up_threshold/max_freq
    EchoWithLog "2133000000" /sys/class/devfreq/ddrfreq_up_threshold/min_freq	

    
    echo "end execute modify cfg, time is : ${CURRENTTIME}" >> ${LOGFILE}
}

main
